module Triple where

import System.Environment
import System.CPUTime
import Control.Monad.CC

do_fail :: Prompt ans [[Integer]] -> CC ans [Integer]
do_fail failP = shift0 failP (\k -> return [])

do_flip :: Prompt ans [[Integer]] -> CC ans Bool
do_flip flipP = shift0 flipP (\k ->
                                 do ts <- (k $ return True)
                                    fs <- (k $ return False)
                                    return (ts ++ fs))

choice :: Prompt ans [[Integer]] -> Prompt ans [[Integer]] -> Integer -> CC ans Integer
choice flipP failP n =
  if (n < 1)
  then shift0 failP (\k -> return [])
  else do side <- do_flip flipP
          if side
          then (choice flipP failP (n - 1))
          else return n

triple :: Prompt ans [[Integer]] -> Prompt ans [[Integer]] -> Integer -> Integer -> CC ans [Integer]
triple flipP failP n s =
  do i <- choice flipP failP n
     j <- choice flipP failP (i-1)
     k <- choice flipP failP (j-1)
     if (s == i+j+k)
     then return [i, j, k]
     else do_fail failP

to_list :: Prompt ans [[Integer]] -> CC ans [[Integer]] -> CC ans [[Integer]]
to_list failP prog = pushPrompt failP prog

collect :: Prompt ans [[Integer]] -> CC ans [[Integer]] -> CC ans [[Integer]]
collect flipP prog = pushPrompt flipP prog

handled_triples_list n s = do flipP <- newPrompt
                              failP <- newPrompt
                              collect flipP (to_list failP (do t <- (triple flipP failP n s)
                                                               return [t]))

go n = print (length (runCC (handled_triples_list n n)))

timed_go n = do start <- getCPUTime
                r <- go n
                end <- getCPUTime
                putStr "cpu msec: "
                print (quot (end - start) 1000000000)

timed_go_many n runs =
  if (runs == 1)
  then timed_go n
  else do timed_go n
          timed_go_many n (runs-1)

main = do args <- getArgs
          let n = (read $ head args :: Integer)
          let runs = (read $ head (tail args) :: Integer)
          timed_go_many n runs
