{-# LANGUAGE FlexibleInstances #-}

module Triple where

import System.Environment
import System.CPUTime

import CCExc

import Data.List (sort)
import Control.Monad
import Control.Applicative
import Control.Monad.Identity
import Control.Monad (MonadPlus(..), liftM2, msum)
-- import System.CPUTime

failP = 0
flipP = 0

do_fail failP = shift0P p2L (\k -> return [])

do_flip flipP = shift0P p2R (\k ->
                                 do ts <- (k True)
                                    fs <- (k False)
                                    return (ts ++ fs))

choice flipP failP n =
  if (n < 1)
  then shift0P p2L (\k -> return [])
  else do side <- do_flip flipP
          if side
          then (choice flipP failP (n - 1))
          else return n

triple flipP failP n s =
  do i <- choice flipP failP n
     j <- choice flipP failP (i-1)
     k <- choice flipP failP (j-1)
     if (s == i+j+k)
     then return [i, j, k]
     else do_fail failP

to_list failP prog = pushPrompt p2L prog

collect flipP prog = pushPrompt p2R prog

handled_triples_list n s = collect flipP (to_list failP (do t <- (triple flipP failP n s)
                                                            return [t]))

go_list :: Integer -> [[[Integer]]]
go_list n = runCC (handled_triples_list n n)

go n = print (length (head (go_list n)))

timed_go n = do start <- getCPUTime
                r <- go n
                end <- getCPUTime
                putStr "cpu msec: "
                print (quot (end - start) 1000000000)

timed_go_many n runs =
  if (runs == 1)
  then timed_go n
  else do timed_go n
          timed_go_many n (runs-1)

main = do args <- getArgs
          let n = (read $ head args :: Integer)
          let runs = (read $ head (tail args) :: Integer)
          timed_go_many n runs
