#lang racket/base
(require racket/control
         racket/list
         racket/function
         racket/cmdline)

(define fail (make-continuation-prompt-tag))
(define flip (make-continuation-prompt-tag))

(define (do-fail) (shift0-at fail k empty))
(define (do-flip) (shift0-at flip k (append (k #true) (k #false))))

(define (choice n)
  (if (< n 1)
      (do-fail)
      (if (do-flip)
          (choice (- n 1))
          n)))

(define (triple n s)
  (let* ([i (choice n)]
         [j (choice (- i 1))]
         [k (choice (- j 1))])
    (if (= s (+ i j k))
        (list i j k)
        (do-fail))))


(define (to-list prog)
  (prompt0-at fail (prog)))

(define (collect prog)
  (prompt0-at flip (prog)))

(define (handled-triples-list n s)
  (collect (thunk
            (to-list (thunk
                      (list (triple n s)))))))

(command-line
 #:args (N runs)
 (let ([N (string->number N)])
   (for/fold ([v #f]) ([i (in-range (string->number runs))])
     (time (length (handled-triples-list N N))))))
