(define-syntax thunk
  (syntax-rules ()
    [(_ e ...) (lambda () e ...)]))

(define fail (newPrompt))
(define flip (newPrompt))

(define-syntax shift0-at
  (syntax-rules ()
    [(_ P id exp ...)
     (withSubCont
      P
      (lambda (s)
        (pushPrompt
         P
         (let ([id (lambda (v) (pushPrompt P (pushSubCont s v)))])
           exp ...))))]))

(define (do-fail) (shift0-at fail k '()))
(define (do-flip) (shift0-at flip k (append (k #t) (k #f))))

(define (choice n)
  (if (< n 1)
      (do-fail)
      (if (do-flip)
          (choice (- n 1))
          n)))

(define (triple n s)
  (let* ([i (choice n)]
         [j (choice (- i 1))]
         [k (choice (- j 1))])
    (if (= s (+ i j k))
        (list i j k)
        (do-fail))))


(define (to-list prog)
  (pushPrompt fail (prog)))

(define (collect prog)
  (pushPrompt flip (prog)))

(define (handled-triples-list n s)
  (collect (thunk
            (to-list (thunk
                      (list (triple n s)))))))
